# $Revision: 1.35 $, $Date: 2007-09-22 18:06:50 $
# TODO
# - more bconds (??)
# - /etc/sysconfig/nginx file
# - prepare style like nginx.conf
#
# Conditional build for nginx:
%bcond_without	stub_status		# stats module
%bcond_without	rtsig
%bcond_without	select
%bcond_without	poll
%bcond_without	ssl			# ssl support
%bcond_without	imap			# imap proxy
%bcond_without	addition
#%bcond_without	perl			# perl module
%bcond_with	http_browser		# header "User-agent" parser
#
Summary:	High perfomance HTTP and reverse proxy server
Summary(pl.UTF-8):	Serwer HTTP i odwrotne proxy o wysokiej wydajności
Name:		nginx
Version:	0.5.31
Release:	4
License:	BSD-like
Group:		Networking/Daemons
Source0:	http://sysoev.ru/nginx/%{name}-%{version}.tar.gz
# Source0-md5:	d84ef8e624b8953faf9cee2b5da535c1
Source1:	%{name}.init
Source2:	%{name}-mime.types.sh
Source3:	http://www.nginx.eu/favicon.ico
# Source3-md5:	2aaf2115c752cbdbfb8a2f0b3c3189ab
Source4:	http://www.nginx.eu/download/proxy.conf
# Source4-md5:	f5263ae01c2edb18f46d5d1df2d3a5cd
Source5:	http://www.nginx.eu/download/%{name}.monitrc
# Source5-md5:	1d3f5eedfd34fe95213f9e0fc19daa88
Source6:	http://www.nginx.eu/download/%{name}.conf
# Source6-md5:	1c112d6f03d0f365e4acc98c1d96261a
Source7:	%{name}.logrotate
Patch0:		%{name}-config.patch
Patch1:		%{name}-autoindexDoS.patch
URL:		http://nginx.net/
BuildRequires:	mailcap
BuildRequires:	openssl-devel
BuildRequires:	pcre-devel
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRequires:	zlib-devel
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires:	rc-scripts >= 0.2.0
Provides:	group(http)
Provides:	group(nginx)
Provides:	user(nginx)
Provides:	webserver
Conflicts:	logrotate < 3.7-4
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sysconfdir	/etc/%{name}
%define		_nginxdir	/home/services/%{name}

%description
Nginx ("engine x") is a high-performance HTTP server and reverse
proxy, as well as an IMAP/POP3 proxy server. Nginx was written by Igor
Sysoev for Rambler.ru, Russia's second-most visited website, where it
has been running in production for over two and a half years. Igor has
released the source code under a BSD-like license. Although still in
beta, Nginx is known for its stability, rich feature set, simple
configuration, and low resource consumption.

%description -l pl.UTF-8
Serwer HTTP i odwrotne proxy o wysokiej wydajności.


%package -n monit-rc-nginx
Summary:	Nginx  support for monit
Summary(pl.UTF-8):	Wsparcie nginx dla monit
Group:		Applications/System
Requires:	%{name} = %{version}-%{release}
Requires:	monit

%description -n monit-rc-nginx
monitrc file for monitoring nginx webserver server.

%description -n monit-rc-nginx -l pl.UTF-8
Plik monitrc do monitorowania serwera www nginx.


%prep
%setup -q
%patch0 -p0
%patch1 -p0

# build mime.types.conf
sh %{SOURCE2} /etc/mime.types

%build
# NB: not autoconf generated configure
./configure \
	--prefix=%{_prefix} \
	--sbin-path=%{_sbindir}/%{name} \
	--conf-path=%{_sysconfdir}/%{name}.conf \
	--error-log-path=%{_localstatedir}/log/%{name}/error.log \
	--pid-path=%{_localstatedir}/run/%{name}.pid \
	--user=nginx \
	--group=nginx \
	%{?with_stub_status:--with-http_stub_status_module} \
	%{?with_rtsig:--with-rtsig_module} \
	%{?with_select:--with-select_module} \
	%{?with_poll:--with-poll_module} \
	%{?with_ssl:--with-http_ssl_module} \
	%{?with_addition:--with-http_addition_module} \
	%{?with_imap:--with-imap} \
	%{!?with_http_browser:--without-http_browser_module} \
	--http-log-path=%{_localstatedir}/log/%{name}/access.log \
	--http-client-body-temp-path=%{_localstatedir}/cache/%{name}/client_body_temp \
	--http-proxy-temp-path=%{_localstatedir}/cache/%{name}/proxy_temp \
	--http-fastcgi-temp-path=%{_localstatedir}/cache/%{name}/fastcgi_temp \
	--with-cc="%{__cc}" \
	--with-cc-opt="%{rpmcflags}" \
	--with-ld-opt="%{rpmldflags}" \
	%{?debug:--with-debug}

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/etc/rc.d/init.d \
	$RPM_BUILD_ROOT%{_nginxdir}/{cgi-bin,html,errors} \
	$RPM_BUILD_ROOT{%{_localstatedir}/log/{%{name},archive/%{name}},%{_localstatedir}/cache/%{name}} \
	$RPM_BUILD_ROOT{%{_sbindir},%{_sysconfdir}} \
	$RPM_BUILD_ROOT/etc/{logrotate.d,monit}

install conf/* $RPM_BUILD_ROOT%{_sysconfdir}
install mime.types $RPM_BUILD_ROOT%{_sysconfdir}/mime.types
install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
install %{SOURCE3} $RPM_BUILD_ROOT%{_nginxdir}/html/favicon.ico
install html/index.html $RPM_BUILD_ROOT%{_nginxdir}/html
install html/50x.html $RPM_BUILD_ROOT%{_nginxdir}/errors
install %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/proxy.conf
install %{SOURCE5} $RPM_BUILD_ROOT/etc/monit/%{name}.monitrc
install %{SOURCE6} $RPM_BUILD_ROOT%{_sysconfdir}/nginx.conf
install %{SOURCE7} $RPM_BUILD_ROOT/etc/logrotate.d/%{name}

install objs/%{name} $RPM_BUILD_ROOT%{_sbindir}/%{name}

rm -f $RPM_BUILD_ROOT%{_sysconfdir}/*.default
rm -rf $RPM_BUILD_ROOT%{_prefix}/html

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -r -g 213 %{name}
%groupadd -g 51 http
%useradd -r -u 213 -d /usr/share/empty -s /bin/false -c "Nginx HTTP User" -g %{name} %{name}
%addusertogroup %{name} http

%post
for a in access.log error.log; do
	if [ ! -f /var/log/%{name}/$a ]; then
		touch /var/log/%{name}/$a
		chown nginx:nginx /var/log/%{name}/$a
		chmod 644 /var/log/%{name}/$a
	fi
done
/sbin/chkconfig --add %{name}
%service %{name} restart

%preun
if [ "$1" = "0" ]; then
	%service -q %{name} stop
	/sbin/chkconfig --del %{name}
fi

%postun
if [ "$1" = "0" ]; then
	%userremove %{name}
	%groupremove %{name}
fi

%files
%defattr(644,root,root,755)
%doc CHANGES LICENSE README html/index.html conf/nginx.conf
%doc %lang(ru) CHANGES.ru
%attr(754,root,root) /etc/rc.d/init.d/%{name}
%dir %attr(754,root,root) %{_sysconfdir}
%dir %{_nginxdir}
%dir %{_nginxdir}/cgi-bin
%dir %{_nginxdir}/html
%dir %{_nginxdir}/errors
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/%{name}.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/logrotate.d/%{name}
%attr(640,root,root) %{_sysconfdir}/*[_-]*
%attr(640,root,root) %{_sysconfdir}/proxy.conf
%attr(640,root,root) %{_sysconfdir}/mime.types
%attr(755,root,root) %{_sbindir}/%{name}
%attr(770,root,%{name}) /var/cache/%{name}
%attr(750,root,root) %dir /var/log/archive/%{name}
%attr(750,%{name},logs) /var/log/%{name}
%config(noreplace,missingok) %verify(not md5 mtime size) %{_nginxdir}/html/*
%config(noreplace,missingok) %verify(not md5 mtime size) %{_nginxdir}/errors/*

%files -n monit-rc-nginx
%defattr(644,root,root,755)
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/monit/%{name}.monitrc

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: nginx.spec,v $
Revision 1.35  2007-09-22 18:06:50  areq
- fix DoS in autoindex module

Revision 1.34  2007/09/19 18:08:51  sardzent
- typo

Revision 1.33  2007/09/19 17:57:59  sardzent
- bcond --with-http_addition_module
- bcond --with-http_perl_module
- P webserver
- with perl module doesn't work need to install files and move to subpackage

Revision 1.32  2007/09/11 12:30:07  gotar
- oops, it's 3.7-4 not 3.7.4

Revision 1.31  2007/09/11 12:15:57  gotar
- C: logrotate < 3.7.4 due to archiv -> archive transition

Revision 1.30  2007/09/11 11:54:42  sardzent
- fixed requires

Revision 1.29  2007/09/10 17:54:37  sardzent
- added index.html and 50x.html pages

Revision 1.28  2007/09/10 15:31:18  sardzent
- added var/log/archive/nginx dir

Revision 1.27  2007/09/06 16:31:02  sardzent
- clean up with bconds
- some todo

Revision 1.26  2007/09/06 09:18:47  sardzent
- added "Provides" section

Revision 1.25  2007/09/06 09:06:42  glen
- todo, adapter

Revision 1.24  2007/09/06 09:03:35  sardzent
- clean description

Revision 1.23  2007/09/06 09:01:50  sardzent
- logrotate script
- monitrc as subpackage

Revision 1.22  2007/09/05 21:29:31  shadzik
- Sardzentku a czemu ty cofasz rel 1 na 0.1 i mnie oglupiasz? :)
- rel 2 for rebuild (Ac)

Revision 1.21  2007/09/05 21:22:41  shadzik
- rel 1

Revision 1.20  2007/09/05 21:20:58  shadzik
- config macro

Revision 1.19  2007/09/05 20:55:04  sardzent
- %dir html and perms for favicon.ico

Revision 1.18  2007/09/05 19:30:56  sardzent
- some bconds
- added favicon.ico
- serverroot /home/services/nginx/
- missing error pages
- missing logrotate
- added nginx.monitrc

Revision 1.17  2007/09/05 17:09:41  sardzent
- added with-http_stub_status_module

Revision 1.16  2007/08/19 12:54:59  areq
- 0.5.31

Revision 1.15  2007/06/28 22:39:44  mis
- update to 0.5.26

Revision 1.14  2007/06/03 17:20:40  areq
- 0.5.22

Revision 1.13  2007/05/16 08:57:37  glen
- rel 1

Revision 1.12  2007/05/16 07:09:44  spider
- up to 0.5.20

Revision 1.11  2007/04/21 21:54:27  areq
- 0.5.18

Revision 1.10  2007/02/25 15:39:42  glen
- generate mime.types
- pass --user,--group nginx to configure

Revision 1.9  2007/02/25 15:33:45  mis
- free uid/gid

Revision 1.8  2007/02/25 15:21:26  glen
- cleanups, gid 212 is already reserved

Revision 1.7  2007/02/25 15:05:41  mis
- added initscript, logs and cache directories
- runned as nginx user
- updated to 0.5.14
- spec cleanup

Revision 1.6  2007/02/13 07:16:49  glen
- tabs in preamble

Revision 1.5  2007/02/12 00:49:13  baggins
- converted to UTF-8

Revision 1.4  2007/01/31 01:00:21  aredridel
- 0.5.10

Revision 1.3  2007/01/31 00:38:18  aredridel
- 0.5.10

Revision 1.2  2005/08/17 22:40:45  qboosh
- pl

Revision 1.1  2005/08/13 10:17:14  glen
- new; NFY
